/*
	Copyright (c) 2004-2009, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/

/*
	This is a compiled version of Dojo, built for deployment and not for
	development. To get an editable version, please visit:

		http://dojotoolkit.org

	for documentation and information on getting the source.
*/

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolChangeVisibility"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolChangeVisibility"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.content.widget.ToolNewPage $Revision: 1.11 $

*/
dojo.provide("epages.cartridges.de_epages.content.widget.ToolChangeVisibility");



dojo.declare(
	"epages.cartridges.de_epages.content.widget.ToolChangeVisibility",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		objectTreeId  : 'contentExplorerObjectTree',
		classStoreId  : 'contentClassStore',
		imageUrl      : epages.vars.StoreRoot + '/BO/icons',
		userGroups    : '',
		url           : '?',

		/**
		 * private properties
		 */
		_classStore      :   undefined,
		_objectTree      :   undefined,
		_currentItem     :   undefined,
		_currentNodeItem :   undefined,
		_dialogWidget    :   undefined,
		_advanced        :   false,
		_userGroups      :   [],
		_currentLanguageID : null,

		/**
		 * widget properties
		 */
		templateString:"<div class=\"CommandPane Medium FloatLeft\" dojoAttachPoint=\"clickNode\" dojoAttachEvent=\"onclick:_onClick\">\n  <i dojoAttachPoint=\"imageNode\" class=\"Sprite ico_m_visible\" title=\"{ChangeVisibility}\"></i>\n  <div>{Visibility}</div>\n  <div dojoAttachPoint=\"dialogNode\" style=\"display: none\">\n    <table class=\"FullWidth\">\n      <tr>\n        <td class=\"InputLabelling\"><label for=\"IsVisibleContentView\" dojoAttachPoint=\"VisiblityLabelNode\">{VisibleOnWebsite}</label></td>\n        <td>\n          <form>\n            <input class=\"Radio\" type=\"text\" dojoAttachPoint=\"IsVisibleContentViewOnNode\" id=\"${id}_IsVisibleContentViewOn\"\n              name=\"IsVisibleContentView\" value=\"1\"/>\n            <label for=\"${id}_IsVisibleContentViewOn\" dojoAttachPoint=\"VisiblityOnLabelNode\">{Yes}</label>\n            <input class=\"Radio\" type=\"text\" dojoAttachPoint=\"IsVisibleContentViewOffNode\" id=\"${id}_IsVisibleContentViewOff\"\n              name=\"IsVisibleContentView\" value=\"0\"/>\n            <label for=\"${id}_IsVisibleContentViewOff\" dojoAttachPoint=\"VisiblityOffLabelNode\">{No}</label>\n            <img src=\"#System.StoreRoot/BO/icons/ico_s_bubblehelp.png\" alt=\"\" class=\"BubbleHelp\" />\n      <span class=\"Tooltip ep-js\" data-js=\"ep.uiTooltip({})\">{BubbleHelpVisibleOnWebsite}</span>\n          </form>\n        </td>\n      </tr>\n      <tr dojoAttachPoint=\"visibleInNavigationNode\">\n        <td class=\"InputLabelling\">{ShownInNavigation}</td>\n        <td>\n          <form>\n            <input class=\"Radio\" type=\"text\" dojoAttachPoint=\"visibleInNavigationOnNode\" id=\"${id}_visibleInNavigationOn\"\n                   name=\"VisibleInNavigation\" value=\"1\"/>\n            <label for=\"${id}_visibleInNavigationOn\">{Yes}</label>\n            <input class=\"Radio\" type=\"text\" dojoAttachPoint=\"visibleInNavigationOffNode\" id=\"${id}_visibleInNavigationOff\"\n              name=\"VisibleInNavigation\" value=\"0\"/>\n            <label for=\"${id}_visibleInNavigationOff\">{No}</label>\n            <img src=\"#System.StoreRoot/BO/icons/ico_s_bubblehelp.png\" alt=\"\" class=\"BubbleHelp\" />\n      <span class=\"Tooltip ep-js\"  data-js=\"ep.uiTooltip({})\">{BubbleHelpVisibleInNavigation}</span>\n          </form>\n        </td>\n      </tr>\n      <tr dojoAttachPoint=\"readPermissionNode\">\n        <td class=\"InputLabelling\"><label for=\"ReadPermissionFor\">{ReadPermissionFor}</label></td>\n        <td>\n          <select name=\"ReadPermissionFor\" dojoAttachPoint=\"readPermissionSelectNode\">\n          </select>\n        </td>\n      </tr>\n      <tr dojoAttachPoint=\"textNode\" style=\"display:none;\">\n        <td class=\"InputLabelling TopPadding\" colspan=\"2\">\n          <table class=\"FullWidth AlignBottom\"><tr><td class=\"AlignBottom\">\n            <label for=\"${id}_textAreaNode\" dojoAttachPoint=\"textAreaLabelNode\"></label>\n          </td><td>\n            <input value=\"{StartWYSIWYGEditor}\"\n                   iconSrc=\"dialog_ico_s_richtext\"\n                   onclick=\"epages.cartridges.de_epages.presentation.richtext.openDialog({\n                          name               :'${id}_textAreaNode',\n                          insertCompleteUrl  : false,\n                          savePage           : false\n                   });\"\n                   type=\"button\" class=\"Button StartWYSIWYG\"\n            />\n          </td></tr></table>\n          <div>\n            <textarea dojoAttachPoint=\"textAreaNode\" id=\"${id}_textAreaNode\" class=\"FullSize\">\n            </textarea>\n          </div>\n          <div class=\"ClearLeft\"></div>\n        </td>\n      </tr>\n    </table>\n  </div>\n</div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.content.widget', 'templates/translation'),
		widgetsInTemplate:true,

		postCreate: function() {
			this.inherited("postCreate", arguments);
			this._classStore = dojo.getObject(this.classStoreId);
			this._objectTree = $$(this.objectTreeId);
			dojo.subscribe(this.objectTreeId+'/select', this, '_onSelectObject');
			dojo.subscribe(this.objectTreeId+'/changeCurrentVisibility',this,'_onSelectObject');

			this.IsVisibleContentViewOnNode = new epages.widget.FormElement({}, this.IsVisibleContentViewOnNode).elementNode;
			this.IsVisibleContentViewOffNode = new epages.widget.FormElement({}, this.IsVisibleContentViewOffNode).elementNode;
			this.visibleInNavigationOnNode = new epages.widget.FormElement({}, this.visibleInNavigationOnNode).elementNode;
			this.visibleInNavigationOffNode = new epages.widget.FormElement({}, this.visibleInNavigationOffNode).elementNode;
			this.readPermissionSelectNode = new epages.widget.FormElement({}, this.readPermissionSelectNode).elementNode;

			dojo.connect(this.IsVisibleContentViewOnNode, 'onclick', this, '_onClickIsVisibleContentView');
			dojo.connect(this.IsVisibleContentViewOffNode, 'onclick', this, '_onClickIsVisibleContentView');

			var groups = this.userGroups.split(",");
			for( var i=0,iLength=groups.length ; i<iLength ; i++ ){
				var group = groups[i].split("|");
				if(group && group[0] && group[1]){
					var groupId = parseInt(group[0]);
					var groupName = group[1];
					var optionNode = document.createElement('option');
					optionNode.value = groupId;
					optionNode.innerHTML = groupName;
					this.readPermissionSelectNode.appendChild(optionNode);
				}
			}

		},

		_onSelectObject:function(node){
			this._currentClassId = node.item.classId;
			this._currentItem = this._classStore.fetchItemByIdentity(this._currentClassId);
			this._currentNodeItem = node.item;

			this._changeVisibilityIcon(node.item.IsVisibleContentView);
			if(this._currentItem.EffectedVisibilityAttributes){
				var attr = this._currentItem.EffectedVisibilityAttributes;
				if(attr.IsVisibleContentView){
					this._advanced = false;
					this.VisiblityLabelNode.innerHTML = this.translate('Visible');
					this.VisiblityOnLabelNode.innerHTML = this.translate('Yes');
					this.VisiblityOffLabelNode.innerHTML = this.translate('No');
					if(parseInt(this._currentNodeItem.IsVisibleContentView) == 1) {
						$$(this.IsVisibleContentViewOnNode.id).setChecked(true);
						$$(this.IsVisibleContentViewOnNode.id).domNode.checked=true;
					}else {
						$$(this.IsVisibleContentViewOffNode.id).setChecked(true);
					}
				}
				//EPG-19425 on these pages it should not be able to change read permission
				var excludePages = /TermsAndConditions|CustomerInformation|PrivacyPolicy|Imprint/;
				if(attr.ReadPermissionFor && !(this._currentItem.alias.match(excludePages))){
					this._advanced = true;
					this.readPermissionNode.style.display = '';
					var selectedIndex = null;
					for( var i=0,iLength=this.readPermissionSelectNode.options.length ; i<iLength ; i++ ){
						var el = this.readPermissionSelectNode.options[i];
						if(el.value == node.item.ReadPermissionFor){
							selectedIndex = el.index;
						}
					}
					if(selectedIndex != null){
						this.readPermissionSelectNode.selectedIndex = selectedIndex;
					}
				}
				else {
					this.readPermissionNode.style.display = 'none';
				}
				if(attr.VisibleInNavigation){
					this._advanced = true;
					this.visibleInNavigationNode.style.display = '';
				}
				else{
					this.visibleInNavigationNode.style.display = 'none';
				}
				if(attr.Text){
					this._advanced = true;
					if(attr.Text.Alias && attr.Text.Alias == 'ShopClosedMessage'){
						this.VisiblityLabelNode.innerHTML = this.translate('ShopStatusIs');
						this.VisiblityOnLabelNode.innerHTML = this.translate('IsOpen');
						this.VisiblityOffLabelNode.innerHTML = this.translate('IsClosed');
					}
				}
			}
			else{
				this._advanced = false;
			}
		},

		_onClick: function (evt) {
			if(this._objectTree == undefined){
				this._objectTree = $$(this.objectTreeId);
			}
			if(this._advanced){
				if (this._dialogWidget === undefined){
					this.createModalDialog();
				}
				this._dialogWidget.setTitle(this.translate('ChangeVisibility')+": "+this._currentNodeItem.title);
				this._dialogWidget.show();
				//set radio buttons
				$$( parseInt(this._currentNodeItem.IsVisibleContentView) ?
					this.IsVisibleContentViewOnNode.id :
					this.IsVisibleContentViewOffNode.id ).attr('checked',true);
				$$( parseInt(this._currentNodeItem.VisibleInNavigation) ?
					this.visibleInNavigationOnNode.id :
					this.visibleInNavigationOffNode.id ).attr('checked',true);

				// check radio buttons for visibility: no is checked
				if(this.IsVisibleContentViewOffNode.checked){
					this._manageVisibility(true, [this.visibleInNavigationOnNode, this.visibleInNavigationOffNode, this.readPermissionSelectNode]);
				// yes is checked
				}else if(this.IsVisibleContentViewOnNode.checked){
					this._manageVisibility(false, [this.visibleInNavigationOnNode, this.visibleInNavigationOffNode, this.readPermissionSelectNode]);
				}

				var visibilityText = this._currentItem.EffectedVisibilityAttributes.Text;
				if(visibilityText){
					this.textNode.style.display = '';
					this.VisibleNavigationTooltip.style.display = 'none';
					this.VisibleTooltip.style.display = 'none';
					var languageNative = null;
					for( var i=0,iLength=epages.vars.CurrentLanguages.length ; i<iLength ; i++ ){
						var elm = epages.vars.CurrentLanguages[i];
						if(elm.LocaleID == contentEventHandler._locale){
							this._currentLanguageID = elm.LanguageID;
							languageNative = elm.Native;
						}
					}
					if(!this._currentItem.EffectedVisibilityAttributes.Text.originalValue || !this._currentItem.EffectedVisibilityAttributes.Text.originalValue[this._currentLanguageID]){
						var json = new epages.io.Json();
						var result = json.loadSync(this.url, {
							'ViewAction': 'JSONGet',
							'Attributes': visibilityText.Alias,
							'ObjectID'  : epages.vars.SiteID,
							'LanguageID': this._currentLanguageID
						});
						if(!result.error){
							if(!this._currentItem.EffectedVisibilityAttributes.Text.originalValue){
								this._currentItem.EffectedVisibilityAttributes.Text.originalValue = {};
							}
							this._currentItem.EffectedVisibilityAttributes.Text.originalValue[this._currentLanguageID] = result.data[visibilityText.Alias];
						}
					}
					var textAreaValue = '';
					if(this._currentItem.EffectedVisibilityAttributes.Text.originalValue[this._currentLanguageID]){
						textAreaValue = this._currentItem.EffectedVisibilityAttributes.Text.originalValue[this._currentLanguageID];
					}
					var objectId = this._currentItem.EffectedVisibilityAttributes.Text.objectId ? this._currentItem.EffectedVisibilityAttributes.Text.objectId : epages.vars.SiteID;
					var inputId = visibilityText.Alias+'Input_'+objectId+'_'+this._currentLanguageID;
					if($(inputId)){
						textAreaValue = $(inputId).value;
					}
					this.textAreaNode.value= textAreaValue;
					this.textAreaLabelNode.innerHTML = this.translate(visibilityText.Alias);
				}
				else {
					this.textNode.style.display = 'none';
					this.VisibleNavigationTooltip.style.display = '';
					this.VisibleTooltip.style.display = '';
				}
			}
			else{
				this._objectTree.changeVisibilityCurrent();
			}
		},

		_onClickIsVisibleContentView: function(evt){
			// check radio buttons for visibility: no is checked
			if(this.IsVisibleContentViewOffNode.checked){
				this._manageVisibility(true, [this.visibleInNavigationOnNode, this.visibleInNavigationOffNode, this.readPermissionSelectNode]);
			// yes is checked
			}else if(this.IsVisibleContentViewOnNode.checked){
				this._manageVisibility(false, [this.visibleInNavigationOnNode, this.visibleInNavigationOffNode, this.readPermissionSelectNode]);
			}
		},

		_manageVisibility: function(visible, nodeList){
			var strOp = visible? "addClass" : "removeClass";

			for(var key in nodeList){
				var objTmp = nodeList[key];
				if(objTmp){
					objTmp.disabled = visible;
					dojo[strOp](objTmp.parentNode, "Disabled");
				}
			}
		},

		createModalDialog: function () {
			
			var me = this;
			this._dialogWidget = new epages.widget.Modaldialog({
				options:{
					title : this.translate('ChangeVisibility'),
					width : 450,
					scroll: "auto",
					content: this.dialogNode
				},
				buttons: [{
					label: this.translate('Apply'),
					//cssClass: 'Disabled',
					onclick: function() {
						me.changeAttributes();
						this._modalDialogWidget.hide();
					}
				},{
					label: epages.io.dictionary.get('Cancel'),
					onclick: function() {
						this._modalDialogWidget.hide();
					}
				}]
			});
			document.body.appendChild(this._dialogWidget.domNode);
			this.dialogNode.style.display = "";
		},

		_changeVisibilityIcon: function(status){
			this.imageNode.src = this.imageUrl + ((status == 1 ) ? '/ico_m_visible.png' : '/ico_m_notvisible.png');
		},

		changeAttributes: function(){
			var attr = this._currentItem.EffectedVisibilityAttributes;
			var objectId = this._objectTree.currentItem().objectId;
			if(attr.ReadPermissionFor){
				if(this.readPermissionSelectNode.options[this.readPermissionSelectNode.selectedIndex].value != this._currentNodeItem.ReadPermissionFor){
					this._objectTree.model.store.changeAttribute(
						{
							objectId: objectId,
							name:'ReadPermissionFor',
							value:this.readPermissionSelectNode.options[this.readPermissionSelectNode.selectedIndex].value
						}
					);
				}
			}
			if(attr.VisibleInNavigation){
				var VisibleInNavigationNew = this.visibleInNavigationOnNode.checked  == true ? 1 : 0;
				var objectId = this._objectTree.currentItem().objectId;
				if(parseInt(this._currentNodeItem.VisibleInNavigation) != VisibleInNavigationNew){
					this._objectTree.model.store.changeAttribute(
						{
							objectId: objectId,
							name:'VisibleInNavigation',
							value:VisibleInNavigationNew
						}
					);
				}
			}
			if(attr.IsVisibleContentView){
				var IsVisibleContentViewNew = this.IsVisibleContentViewOnNode.checked == true ? 1 : 0;
				if(parseInt(this._currentNodeItem.IsVisibleContentView) != IsVisibleContentViewNew){
					this._objectTree.changeVisibilityCurrent();
				}
			}
			if(attr.Text && this._currentLanguageID){
				var name = attr.Text.Alias;
				var textNew = this.textAreaNode.value;
				if(textNew != attr.Text.originalValue[this._currentLanguageID]){
					this._objectTree.model.store.changeAttribute(
						{
							objectId: epages.vars.SiteID,
							name:name,
							value:textNew,
							languageId: this._currentLanguageID,
							oldValue: attr.Text.originalValue[this._currentLanguageID]
						}
					);
					attr.Text.originalValue[this._currentLanguageID] = textNew;
				}
			}
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolMovePage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolMovePage"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.content.widget.ToolNewPage $Revision: 1.14 $

*/
dojo.provide("epages.cartridges.de_epages.content.widget.ToolMovePage");


dojo.declare(
	"epages.cartridges.de_epages.content.widget.ToolMovePage",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		uri           : '?',
		objectTreeId  : 'contentExplorerObjectTree',
		classStoreId  : 'contentClassStore',
		objectStoreId : 'objectStore',
		imagePath     : epages.themeUrl('images'),
		horizontalMovement: true,//is indent and outdent allowed, feature dependent

		/**
		 * private properties
		 */
		 _classStore  : undefined,
		 _objectStore : undefined,
		 _objectTree  : undefined,

		_upClickConnect: undefined,
		_downClickConnect: undefined,
		_leftClickConnect: undefined,
		_rightClickConnect: undefined,

		/**
		 * widget properties
		 */
		templateString:"<div class=\"ToolMovePage\">\n  {MovePage}<br />\n  <span class=\"Buttons\">\n    <div class=\"CommandMedium DisabledButton\"><i class=\"Sprite ico_m_move_up\" dojoAttachpoint=\"moveUpNode\" title=\"{PageUp}\"></i></div>\n    <div class=\"CommandMedium DisabledButton\"><i class=\"Sprite ico_m_move_down\" dojoAttachpoint=\"moveDownNode\" title=\"{PageDown}\"></i></div>\n    <div class=\"CommandLineBreak\"></div>\n    <div class=\"CommandMedium DisabledButton\"><i class=\"Sprite ico_m_indent\" dojoAttachpoint=\"indentNode\" title=\"{PageIndent}\"></i></div>\n    <div class=\"CommandMedium DisabledButton\"><i class=\"Sprite ico_m_outdent\" dojoAttachpoint=\"outdentNode\" title=\"{PageOutdent}\"></i></div>\n  </span>\n</div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.content.widget', 'templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.objectTreeId+'/select', this, '_onSelectObject');
			this._classStore = dojo.getObject(this.classStoreId);
			this._objectStore = dojo.getObject(this.objectStoreId);
			this._objectTree = $$(this.objectTreeId);
			if(this.horizontalMovement == false){
				dojo.addClass(this.indentNode, 'HideElement');
				dojo.addClass(this.outdentNode, 'HideElement');
			}
		},

		objectTree: function () {
			if (!this._objectTree) {
				this._objectTree = $$(this.objectTreeId);
				if (!this._objectTree){
					console.warn('%s is not a tree', this.objectTreeId);
				}
			}
			return this._objectTree;
		},

		_onMoveDown: function () { this.objectTree().moveDownCurrent();this._onSelectObject(this.objectTree().lastFocused);},
		_onMoveUp:   function () { this.objectTree().moveUpCurrent();  this._onSelectObject(this.objectTree().lastFocused);},
		_onOutdent:  function () { this.objectTree().outdentCurrent(); this._onSelectObject(this.objectTree().lastFocused); delete this._objectStore.indentNode;},
		_onIndent:   function () { this.objectTree().indentCurrent();  this._onSelectObject(this.objectTree().lastFocused); delete this._objectStore.indentNode;},

		_onSelectObject:function(node){
			// move down
			if (this._objectStore.canMoveItem(1, node.item)&&this.canMoveItem(1,node.item)) {
				if (this._downClickConnect === undefined) {
					dojo.removeClass(this.moveDownNode.parentNode,'DisabledButton');
					this._downClickConnect = this.connect(this.moveDownNode.parentNode,'click', '_onMoveDown')[0];
				}
			} else {
				if (this._downClickConnect !== undefined) {
					dojo.addClass(this.moveDownNode.parentNode,'DisabledButton');
					dojo.disconnect(this._downClickConnect);
					this._downClickConnect = undefined;
				}
			}
			// move up
			if (this._objectStore.canMoveItem(-1, node.item) && this.canMoveItem(-1,node.item)) {
				if (this._upClickConnect === undefined) {
					dojo.removeClass(this.moveUpNode.parentNode,'DisabledButton');
					this._upClickConnect = this.connect(this.moveUpNode.parentNode,'click', '_onMoveUp')[0];
				}
			} else {
				if (this._upClickConnect !== undefined) {
					dojo.addClass(this.moveUpNode.parentNode,'DisabledButton');
					dojo.disconnect(this._upClickConnect);
					this._upClickConnect = undefined;
				}
			}
			// outdent
			if (this._objectStore.canOutdentItem(node.item) && this.canOutdentItem(node.item)) {
				if (this._outdentClickConnect === undefined) {
					dojo.removeClass(this.outdentNode.parentNode,'DisabledButton');
					this._outdentClickConnect = this.connect(this.outdentNode.parentNode,'click', '_onOutdent')[0];
				}
			} else {
				if (this._outdentClickConnect !== undefined) {
					dojo.addClass(this.outdentNode.parentNode,'DisabledButton');
					dojo.disconnect(this._outdentClickConnect);
					this._outdentClickConnect = undefined;
				}
			}
			// indent
			if (this._objectStore.canIndentItem(node.item) && this.canIdentItem(node.item)) {
				if (this._indentClickConnect === undefined) {
					dojo.removeClass(this.indentNode.parentNode,'DisabledButton');
					this._indentClickConnect = this.connect(this.indentNode.parentNode,'click', '_onIndent')[0];
				}
			} else {
				if (this._indentClickConnect !== undefined) {
					dojo.addClass(this.indentNode.parentNode,'DisabledButton');
					dojo.disconnect(this._indentClickConnect);
					this._indentClickConnect = undefined;
				}
			}
		},

		canIdentItem: function(item) {
			var upper = this._findCloseByVisibleItem(item,-1);
			if(upper == undefined){
				return null;
			}
			var upperClass = this._classStore.fetchItemByIdentity(upper.classId);

			return null != $A(upperClass.contentChildClasses).find(item.classId);
		},

		canOutdentItem: function(item) {
			var parent = this._objectStore.fetchItemByIdentity(item.parentId);
			var parentClass = this._classStore.fetchItemByIdentity(parent.classId);

			return null != $A(parentClass.contentChildClasses).find(item.classId);
		},

		_findCloseByVisibleItem: function(item,step){
			//summary: find item that is close to the given one
			//step is the movment defines if the item cames before or after the current item
			var parent = this._objectStore.fetchItemByIdentity(item.parentId);
			var childrenIds = parent.children;
			var foundItem = $A(childrenIds).find(item.objectId);
			var upper = this._objectStore.fetchItemByIdentity(childrenIds[foundItem+step]);
			if(upper == undefined){
				return undefined;
			}
			if(upper.isDeleted == false){
				return upper;
			}
			else{
				return this._findCloseByVisibleItem(upper);
			}
		},

		canMoveItem:function(step,item){
			var upper = this._findCloseByVisibleItem(item,step);
			if(upper == undefined){
				return false;
			}
			else{
				return true;
			}
		}
	}
);

}

if(!dojo._hasResource['epages.lang.sort']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.lang.sort'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.lang.sort $Revision: 1.3 $

*/
dojo.provide('epages.lang.sort');

epages.lang.sort = {
	integer:  function (a,b) { return a - b; },
	position: function (a,b) { return a.position - b.position; }
}

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolNewPage"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.ToolNewPage"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.content.widget.ToolNewPage $Revision: 1.22 $

*/
dojo.provide("epages.cartridges.de_epages.content.widget.ToolNewPage");







dojo.declare(
	"epages.cartridges.de_epages.content.widget.ToolNewPage",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		uri           : '?',
		objectTreeId  : 'contentExplorerObjectTree',
		classStoreId  : 'contentClassStore',
		imageUrl      : epages.vars.StoreRoot + '/BO/icons',
		widgetsInTemplate  : true,
		disabled      : false,

		/**
		 * private properties
		 */
		_classStore :   undefined,
		_currentClassId: undefined,					// current classid of selected element in tree
		_overloadClassId: undefined,				// overload currentClassId (to create a new page on different page) - temporary only
		_overloadObjectId : undefined, 			// overload current parent object - temporary only
		_newPageWidget:  undefined,
		_imageClickConnect: undefined,
		_selectedItemNoFeature: false,

		/**
		 * widget properties
		 */
		templateString:"<div class=\"ToolNewPage CommandPane Medium FloatLeft\">\n  <i dojoAttachPoint=\"imageNode\" class=\"Sprite ico_m_document_new\" title=\"{CreateNewPage}\"></i>\n  <br />\n  {New}\n  <div dojoAttachPoint=\"dialogNode\" class=\"ToolNewPageDialog\" style=\"display: none\">\n    <table>\n      <tr>\n        <td class=\"RightPadding\">{Type}</td>\n        <td>\n          <select class=\"Text\" dojoAttachPoint=\"selectNode\" size=\"9\">\n          </select>\n        </td>\n        <td rowspan=\"3\" class=\"LeftSmallPadding AlignTop\">\n          <div dojoAttachPoint=\"typeNameNode\" class=\"TypeName\"></div>\n          <div dojoAttachPoint=\"typeDescNode\" class=\"TypeDesc\"></div>\n          <div dojoAttachPoint=\"disabledFeatureNode\" class=\"DialogMessageSmall MessageInfo TopMargin\" style=\"display:none\">{FEATURE_LIMIT_EXCEEDED}</div>\n        </td>\n      </tr>\n      <tr>\n        <td class=\"RightPadding\">{Name}<span class=\"MandatoryStar\">{MandatoryStar}</span></td>\n        <td>\n          <input dojoAttachPoint=\"newNameWidget\" dojotype=\"epages.widget.FormElement\" type=\"text\" class=\"Name Mandatory\" />\n        </td>\n      </tr>\n      <tr>\n        <td class=\"RightPadding\">{Visible}</td>\n        <td>\n          <input dojoAttachPoint=\"isVisibleOnNode\" id=\"${id}_isVisibleOn\" name=\"IsVisible\" value=\"1\" class=\"Radio\" type=\"text\"/>\n          <label for=\"${id}_isVisibleOn\">{Yes}</label>\n          <input dojoAttachPoint=\"isVisibleOffNode\" id=\"${id}_isVisibleOff\" name=\"IsVisible\" value=\"0\" checked=\"checked\"  class=\"Radio\" type=\"text\"/>\n          <label for=\"${id}_isVisibleOff\">{No}</label>\n        </td>\n      </tr>\n    </table>\n    <br />\n    {MandatoryFields}\n  </div>\n</div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.content.widget', 'templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.objectTreeId+'/select', this, '_onSelectObject');
			this._imageClickConnect = dojo.connect(this.imageNode.parentNode, 'click', this, '_onClick');
			this._classStore = dojo.getObject(this.classStoreId);
			this.isVisibleOffNode = new epages.widget.FormElement({}, this.isVisibleOffNode).elementNode;
			this.isVisibleOnNode = new epages.widget.FormElement({}, this.isVisibleOnNode).elementNode;
			this.selectNode = new epages.widget.FormElement({}, this.selectNode).elementNode;
			this.connect(this.selectNode,'onchange', '_onChangeType');
			this.connect(this.newNameWidget.domNode,'onkeyup', '_onChangeName');
		},

		_onSelectObject:function(node) {
			this._currentClassId = node.item.classId;
			this._overloadClassId = undefined;  // reset _overloadClassId
			this._overloadObjectId = undefined; // reset _overloadObjectId
			var item = this._classStore.fetchItemByIdentity(this._currentClassId);
			if(item.contentChildClasses.length == 0) {
				var parentNode = node.getParent();
				if(parentNode && parentNode.item && parentNode.item.classId){
					this._currentClassId = parentNode.item.classId;
					this._overloadClassId = parentNode.item.classId;
					this._overloadObjectId = parentNode.item.objectId;
				}
			}
				if (this._imageClickConnect === undefined) {
					this._imageClickConnect = dojo.connect(this.imageNode, 'click', this, '_onClick');
				}
				dojo.publish(this.id+"/enabled", []);
				this.disabled=false;
		},

		_onClick: function (/* event */ evt, /* object? */ opt) {
		// summary: init & open dialog
		//  event - event object
		//  opt - options object
		//    preselectedClass -> this ClassID will be preselected
		//    overloadClassId  -> ClassID overload parent object
		//    overloadObjectId -> ObjectID overload parent object
			if(opt) {
				if(opt.overloadClassId) {
					this._overloadClassId=opt.overloadClassId;
				}
				if(opt.overloadObjectId) {
					this._overloadObjectId = opt.overloadObjectId;
				}
			}

			if (this._newPageWidget === undefined) {
				this.createModalDialog();
			}
			this.refreshInputs(this._currentClassId, (opt && opt.preselectedClass) ? opt.preselectedClass : undefined );
			this._newPageWidget.show();

			setTimeout(dojo.hitch(this, function() {
				epages.event.fire( this.newNameWidget.domNode, 'focus' );
				this.newNameWidget.domNode.focus();
				this.newNameWidget.domNode.select();
			}), 200);
		},

		refreshInputs: function (/* string */ classId, preselectedClass) {
		// summary: load options in select field
		//  classId - ClassID of current page
			var item = this._classStore.fetchItemByIdentity(this._overloadClassId ? this._overloadClassId : classId);
			epages.html.removeChildren(this.selectNode);
			var classItems = [];
			var hasSel = false;
			dojo.forEach(item.contentChildClasses, function (el) {
				classItems.push(this._classStore.fetchItemByIdentity(el));
			}, this);
			dojo.forEach(classItems.sort(epages.lang.sort.position), function (optionItem) {
				var feature = optionItem.feature;
				var option = document.createElement('option');
				option.value=optionItem.objectId;
				option.innerHTML=optionItem.title;
				if(feature.currentValue != undefined && feature.maxValue != undefined && (
					parseInt(optionItem.feature.currentValue) >= parseInt(optionItem.feature.maxValue))){
					dojo.addClass(option, "FeatureDisabled");
				}
				if(!hasSel) {
					option.selected=true;
					hasSel = true;
				}
				this.selectNode.appendChild(option);
			}, this);

			this.newNameWidget.domNode.value='';
			dojo.removeClass(this._newPageWidget.buttons[0].domNode,'Active');
			dojo.addClass(this._newPageWidget.buttons[0].domNode,'Disabled');
			$$(this.isVisibleOffNode.id).setChecked(true);

			if(preselectedClass) {
				this.selectNode.value = preselectedClass;
				if(this.selectNode.value == preselectedClass) {
					this.newNameWidget.attr('value',this.selectNode[this.selectNode.selectedIndex].text);
				}
			} else {
				this.selectNode.startupIndex = 0;
			}

			this._onChangeType();

		},

		createModalDialog: function () {
			
			var me = this;
			this._newPageWidget = new epages.widget.Modaldialog({
				options:{
					title : this.translate('CreateNewPage'),
					width : 530,
					height: 210,
					scroll: "auto",
					content: this.dialogNode
				},
				buttons: [{
					label: this.translate('Insert'),
					cssClass: 'Disabled',
					onclick: function() {
						if(!dojo.hasClass(this.domNode,'Disabled')){
							dojo.addClass(this.domNode,'Disabled');
							dojo.removeClass(this.domNode,'Active');
							var isVisibleTemp = me.isVisibleOnNode.checked;
							var objectTree = $$(me.objectTreeId);
							var tmpObjectId = me._overloadObjectId;
							if(me._overloadObjectId) {
								objectTree.selectNodeByObjectId(me._overloadObjectId);
							}
							me._overloadClassId = undefined; 	// reset _overloadClassId
							me._overloadObjectId = undefined; // reset _overloadObjectId
							objectTree.createObject(me.selectNode, me.newNameWidget.domNode, me.translate('EnterAlias'),tmpObjectId,isVisibleTemp);
							this._modalDialogWidget.hide();
						}
					}
				},{
					label: epages.io.dictionary.get('Cancel'),
					onclick: function() {
						this._modalDialogWidget.hide();
					}
				}]
			});
			document.body.appendChild(this._newPageWidget.domNode);
			this.dialogNode.style.display="";
		},

		_setSaveButton: function(isTooLong) {
			if(this.newNameWidget.domNode.value !== '' && !this._selectedItemNoFeature && !isTooLong){
				dojo.removeClass(this._newPageWidget.buttons[0].domNode,'Disabled');
				dojo.addClass(this._newPageWidget.buttons[0].domNode,'Active');
			} else {
				dojo.removeClass(this._newPageWidget.buttons[0].domNode,'Active');
				dojo.addClass(this._newPageWidget.buttons[0].domNode,'Disabled');
			}

			if(this._selectedItemNoFeature) {
				dojo.addClass(this.selectNode, "DialogErrorNormalFontWeight Force");
			} else {
				dojo.removeClass(this.selectNode, "DialogErrorNormalFontWeight Force");
			}
		},

		_onChangeName: function(evt){
			var isTooLong = this.newNameWidget.domNode.value.length>100;
			
			dojo[isTooLong? 'addClass' : 'removeClass'](this.newNameWidget.domNode, 'DialogError');
			this._setSaveButton(isTooLong);
		},

		_onChangeType: function(evt) {
			var cTypeId = this.selectNode.value;
			var item = this._classStore.fetchItemByIdentity(cTypeId);
			if(item) {
				var icName=epages.cartridges.de_epages.presentation.icon.getIconFileName(item.alias, true, false, 'l');
				if(item.title){
					this.typeNameNode.innerHTML=item.title;
					this.newNameWidget.domNode.value = item.title;
					this.newNameWidget.domNode.select();
				}else{
					this.typeNameNode.innerHTML="";
				}
				if(item.description){
					this.typeDescNode.innerHTML=item.description;
				}else{
					this.typeDescNode.innerHTML="";
				}
				var feature = item.feature;
				if(feature.currentValue != undefined && feature.maxValue != undefined && (
					parseInt(feature.currentValue) >= parseInt(feature.maxValue))){
					this.disabledFeatureNode.style.display='';
					this._selectedItemNoFeature=true;
				} else {
					this.disabledFeatureNode.style.display='none';
					this._selectedItemNoFeature=false;
				}
				this.typeDescNode.style.backgroundImage="url("+epages.vars.IconsRoot+"/"+icName+")";
				this._setSaveButton();

			}
		}
	}
);

}

if(!dojo._hasResource['epages.cartridges.de_epages.content.ClassStore']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.cartridges.de_epages.content.ClassStore'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.content.ClassStore $Revision: 1.7 $

*/
dojo.provide('epages.cartridges.de_epages.content.ClassStore');





dojo.declare(
	'epages.cartridges.de_epages.content.ClassStore',
	[dojo.data.api.Identity],
	{
		/**
		 * public properties
		 */
		actionInfo         : "JSONContentClasses", // server ViewAction to get children information
		url                : '?',              // request url like '/epages/DemoShop.admin/?'
		objectId           : '',               // objectId for info request
		titleAttribute     : 'NameOrAlias',    // attribute used to show name at tree
		title              : '',               // title of the rode node
		id                 : 'ClassStore',

		/**
		 * private properties
		 */
		_info              : undefined,            // epages.lang.Hash values including information about classes
		_JsonIo            : new epages.io.Json(), // epages.io.Json() JSON communication channel to server
		_serverAttributes  : '',                   // String, list of attributes for server

		constructor: function(keywordParameters){
			dojo.mixin(this,keywordParameters);
			this._info = $H();
			dojo.subscribe('uimessage/stopBusy',this, "_reloadStore");
		},

		_loadList: function(classId) {
			if(classId && !this._info.existsKey(classId)) {
				var jsonData = this._JsonIo.loadSync(this.url, {
					'ViewAction' : this.actionInfo,
					'ObjectID'   : this.objectId,
					'ClassID': classId
				});
				if (jsonData != null && !jsonData.error) {
					// save data at internal structure
					dojo.forEach(jsonData.data, function (el) {
						var info = {
							alias: el.Alias,
							title: el.NameOrAlias,
							objectId: el.ObjectID,
							contentChildClasses: el.ContentChildClasses,
							EffectedVisibilityAttributes: el.EffectedVisibilityAttributes,
							position: el.Position,
							feature: {
								currentValue: el.FeatureCurrentValue ? el.FeatureCurrentValue: undefined,
								maxValue: el.FeatureMaxValue ? el.FeatureMaxValue: undefined
							},
							description : el.Description
						};
						this._info.set(el.ObjectID, info);
					}, this);
				} else {
					return false;
				}
			}
			return true;
		},

		_fetch: function (objectId) {
			var childrenIds = this._info.get(objectId).contentChildClasses;
			var items = [];
			var i;
			dojo.forEach(childrenIds, function(el) {
				i = this._info.get(el);
				if (! i.isDeleted){ 
					items.push(i);
				}
			}, this);
			return items;
		},

		_fetchItems: function(keywordArgs, findCallback, errorCallback){
			if(this._loadList(keywordArgs.query.id) && typeof findCallback == 'function') {
				findCallback(this._fetch(keywordArgs.query.id), keywordArgs);
			} else {
				console.warn('error while _fetch %d', keywordArgs.query.id);
				//errorCallback(keywordArgs);
			}
		},

		fetchItemByIdentity: function(objectId){
			if (this._loadList(objectId)){
				return this._info.get(objectId);
			}
			return undefined;
		},

		hasAttribute: function(node, attributeName){
			return node[attributeName] !== undefined;
		},

		getLabel: function(item){
			return item.title;
		},

		getIdentity: function(item){
			return item.objectId;
		},

		getValue: function(item, attribute){
			console.warn('getValue %s', attribute);
		},

		getValues: function(item, attribute){
			if (attribute == 'children' && this._loadList(item.objectId)) {
				return this._fetch(item.objectId);
			}
			else{
				console.warn('getValues() unknown attribute', attribute);
			}
		},

		isItemLoaded: function(something){
			//console.debug('isItemLoaded');
			return this._info.existsKey(objectId);
		},

		_reloadStore:function(id){
				this._info = $H();
			}
});

dojo.extend(epages.cartridges.de_epages.content.ClassStore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtoolitem"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtoolitem"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Designtoolitem $Revision: 1.5 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Designtoolitem");


dojo.declare(
	"epages.cartridges.de_epages.design.widget.Designtoolitem",
	[dijit._Widget, dijit._Templated, dijit._Contained],
	{
		/**
		 * public properties
		 */
		label: '',
		infoText: '',
		iconSrc: '',
		objectId: '',
		tooltipWidget: undefined,
		 /**
		 * widget properties
		 */
		imagePath         :  epages.themeUrl('images'),
		templateString:"<div class=\"dijitReset dijitMenuItem\"\n    dojoAttachEvent=\"ondijitclick:onClick,onmouseenter:_onHover,onmouseleave:_onUnhover\"\n    style=\"float:left; padding: 3px; margin: 3px 3px 3px 3px\"\n    >\n  <span tabIndex=\"-1\" waiRole=\"menuitem\" >\n  <span class=\"dijitReset dijitMenuItemIcon\" dojoAttachPoint=\"iconNode\" style=\"position:static\"><img src=\"${iconSrc}\" alt=\"\" /><span dojoAttachPoint=\"tooltipNode\"></span></span>\n  <span style=\"display: none\" class=\"dijitReset dijitMenuItemLabel\" dojoAttachPoint=\"containerNode\" ></span>\n  <span style=\"display: none\" class=\"dijitReset\" dojoAttachPoint=\"arrowCell\">\n    <span class=\"dijitMenuExpand\" dojoAttachPoint=\"expand\" style=\"display:none\">\n      <span class=\"dijitInline dijitArrowNode dijitMenuExpandInner\">+</span>\n    </span>\n  </span>\n</div>\n",

		postCreate: function(){
			dojo.setSelectable(this.domNode, false);
			if(this.label){
				this.containerNode.innerHTML=this.label;
			}
			if(this.label != "") {
				var ttContent= "";
				if(this.infoText && this.infoText != ""){
					ttContent = "<b>"+this.label+"</b><br />"+this.infoText;
				}else{
					ttContent = this.label;
				}
				this.tooltipNode.innerHTML= ttContent;
				var tt = new epages.widget.Tooltip({},this.tooltipNode);
				this.tooltipWidget = tt;
			}
		},
		onClick: function() {
		},

		_onHover: function(){
			dojo.addClass(this.domNode, 'dijitMenuItemHover');
		},

		_onUnhover: function(){
			dojo.removeClass(this.domNode, 'dijitMenuItemHover');
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtool"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtool"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Designtool $Revision: 1.29 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Designtool");




dojo.declare(
	"epages.cartridges.de_epages.design.widget.Designtool",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		title:        'Select',
		data:         "",
		imagedir:     "",
		active:       "",
		controllerId: "",
		folder:       "",
		objectId:     "",
		visible:      false,
		position:     99, // to sort folder

		/**
		 * private properties
		 */
		_lookup:  undefined,
		_lastSelected : null,
		_width : "",
		_height: "",
		_overflowY: "scroll",
		_tooltipCoor: null, //coordinates to position tooltip

		/**
		 * constants
		 */

		ITEM_WIDTH     :62, //Width of the div with padding and margin where the ico is in
		ITEM_HEIGHT    :62, //Height of the div with padding and margin where the ico is in
		WIDTH_SCROLLBAR:20, //width of scrollbar
		NUMBER_ITEMS_FIRST_ROW : 5,  // number of items in the first row
		NUMBER_ITEMS_SECOND_ROW: 10, //number of items in the first an second row together
		NUMBER_ITEMS_THIRD_ROW : 15, //number of items in the first, second and third row together

		/**
		 * widget properties
		 */
		declaredClass   : 'epages.design.Designtool',
		imagePath         :  epages.themeUrl('images'),
		templateString:"<div style=\"display:none\" >\n<div class=\"Designtool WithXLIcon\"  dojoAttachPoint=\"DesigntoolNode\"><div dojoAttachPoint=\"seperatorNode\" class=\"VerticalSeperator\"></div>\n  <div class=\"CommandPane ExtraLarge\" dojoAttachPoint=\"clickNode\">\n    ${title}<br />\n    <img dojoAttachPoint=\"SelectedOptionNode\"\n         src=\"${imagePath}/blank.gif\"\n         alt=\"\" title=\"\"\n         /><br />\n    <img src=\"${imagePath}/img_extend.png\"\n         alt=\"\" title=\"${title}\" />\n  </div>\n</div>\n<div class=\"HideElement\" dojoAttachPoint=\"toolTipTarget\"></div>\n</div>\n",
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/translation'),
		widgetsInTemplate: true,

		postMixInProperties: function() {
			if(this.data != "") {
				if (typeof(this.data) == 'string'){
					 this.data = dojo.fromJson(this.data);
				}
				this._lookup = {};
				for( var i=0,l=this.data.length ; i<l ; i++ ) {
					var t = {};
					var s = this.data[i];
					t.objectId = s.ID;
					t.title = s.Name != undefined ? s.Name : '';
					t.image = this.imagedir + '/' + (s.PreviewImage || "general_img_transparentpixel.gif");
					t.text  = s.InfoText;
					t.alias = s.Alias;
					this._lookup[t.objectId] = this.data[i] = t;
				}
			}
			this.inherited("postMixInProperties", arguments);
		},

		postCreate: function () {
			this.inherited("postCreate", arguments);
			this._setWidthHeight();

			this._toolTipWidget= new epages.widget.Tooltip({
				templateString: '<div class="Tooltip DesigntoolMenu"><div class="Menu" style="margin:-12px;"><div class="Layer"><div class="PropertyContainer">' +
						'<div class="dijit dijitMenu dijitReset dijitMenuTable" waiRole="menu">' +
							'<div class="dijitReset" dojoAttachPoint="containerNode"><div dojoAttachPoint="newLayoutsTitleNode" class="HideElement">' + this.translation.get("NewLayouts") + '</div><div dojoAttachPoint="newLayoutsNode" class="HideElement"></div><div class="ClearBoth"></div><div dojoAttachPoint="oldLayoutsTitleNode" class="HideElement">' + this.translation.get("OldLayouts") + '</div><div dojoAttachPoint="oldLayoutsNode"></div><div class="ClearBoth"></div></div>'+
							'</div>'+
						'</div></div>' +
					'<div class="LayerFooter"><div class="PropertyContainer"></div></div></div></div>',
				tooltipArea: this.toolTipTarget,
				interactive: true
			});
			this.DesigntoolNode.appendChild(this._toolTipWidget.domNode);
			// _toolTipWidget style props
			this._toolTipWidget.containerNode.style.height = this._height;
			this._toolTipWidget.containerNode.style.overflowX = "hidden";
			this._toolTipWidget.containerNode.style.overflowY = this._overflowY;
			this._toolTipWidget.containerNode.parentNode.style.width = this._width;
			this._toolTipWidget.containerNode.parentNode.style.paddingTop = "4px";
			setTimeout(dojo.hitch(this, function() {
				this._toolTipWidget.show(-9999, -9999);
				this._toolTipWidget.hide();
			}), 1);
			for( var i=0,l=this.data.length ; i<l ; i++ ) {
				this._addLayout(this.data[i]);
			}
			if(this.active){
				 this.setOption(this.active);
			}
			this.connect(this.clickNode,'onclick', '_OnClickSelector');
		},

		_addLayout: function(layout) {
			var parentWidget = this;
			var entry = new epages.cartridges.de_epages.design.widget.Designtoolitem({
				id : this.title +':'+layout.objectId+':MenuItem',
				label: layout.title,
				infoText: layout.text,
				iconSrc: layout.image,
				objectId: layout.objectId,
				onClick: function() {
					parentWidget.setOption(this.objectId);
					parentWidget._toolTipWidget.hide();
				}
			});
			if(layout.alias.lastIndexOf('_New') != -1){
				dojo.removeClass(this._toolTipWidget.newLayoutsNode,'HideElement');
				dojo.removeClass(this._toolTipWidget.newLayoutsTitleNode,'HideElement');
				dojo.removeClass(this._toolTipWidget.oldLayoutsTitleNode,'HideElement');
				this._toolTipWidget.newLayoutsNode.appendChild(entry.domNode);
			}
			else{
				this._toolTipWidget.oldLayoutsNode.appendChild(entry.domNode);
			}


			if(this.active == layout.objectId){
				dojo.addClass(entry.domNode, "dojoMenuItem2Selected" );
			}
		},

		setOption: function(active,publish,objectId) {
			if(objectId){
				 this.objectId = objectId;
			}
			var menuItem = $$(this.title+':'+active+':MenuItem');
			if(menuItem != this._lastSelected){
				if(this._lastSelected){
					dojo.removeClass(this._lastSelected.domNode, "Selected" );
				}
				dojo.addClass(menuItem.domNode, "Selected" );
				this._lastSelected = menuItem;
				var data = this._lookup[active];
				if (data === undefined || data == null){
					 return;
				}
				this.SelectedOptionNode.src = data.image;
				this.SelectedOptionNode.alt = data.title;
				this.SelectedOptionNode.title = data.title;
				this.active = active;
				if(publish !== false){
					dojo.publish('Designtool/select',[{id : this.id}]);
				}
			}
		},

		getActive: function(){
			if(this.active === ""){
				return undefined;
			}
			else{
				var data = this._lookup[this.active];
				if (data === undefined || data == null){
					 return;
				}
				return {
					folder  : this.folder,
					alias   : data.alias,
					objectId: this.objectId,
					templateTypeId: data.objectId,
					lastSelected : this._lastSelected
				};
			}
		},


		_OnClickSelector: function (opt) {
			var curTarget = $E(opt.currentTarget);
			var coords = curTarget.getAbsolutePosition();
			coords['y']+=curTarget.object.clientHeight;

			this._tooltipCoor = {x:coords['x'],y:coords['y']};
			if(this.controllerId == ""){
				this.openMenuWidget();
			}
			else{
				//if Controller is defined ask if SelectLayout is allowed
				$$(this.controllerId).allowSelectLayout(this.id);
			}
		},

		openMenuWidget: function(){
			this._toolTipWidget.show(parseInt(this._tooltipCoor.x),parseInt(this._tooltipCoor.y));
		},

		_setWidthHeight:function(){
			var layouts = this.data.length;
			var multiWidth = this.NUMBER_ITEMS_FIRST_ROW;
			var multiHeight = 3;
			var scrollbar = 0;
			var overflowY = "hidden";
			if(layouts <= this.NUMBER_ITEMS_FIRST_ROW){
				multiWidth = layouts;
				multiHeight = 1;
				scrollbar = 0;
			}
			else if(layouts > this.NUMBER_ITEMS_FIRST_ROW && layouts <= this.NUMBER_ITEMS_SECOND_ROW){
				multiHeight = 2;
			}
			else if(layouts > this.NUMBER_ITEMS_THIRD_ROW){
				overflowY = "scroll";
				scrollbar = this.WIDTH_SCROLLBAR;
			}
			//this._width = ((multiWidth*this.ITEM_WIDTH)+scrollbar)+"px";
			//this._height = (multiHeight*this.ITEM_HEIGHT)+"px";
			this._overflowY= overflowY;
		},

		show:function(){
			this.visible = true;
			this.domNode.style.display = "";
		},

		hide:function(){
			this.visible = false;
			this.domNode.style.display = "none";
		},
		setSeperator:function(active){
			if(active == true){
				this.seperatorNode.style.display = "";
			}
			else{
				this.seperatorNode.style.display = "none";
			}
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtoolcontroller"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.design.widget.Designtoolcontroller"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Designtoolcontroller $Revision: 1.27 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Designtoolcontroller");







dojo.declare(
	"epages.cartridges.de_epages.design.widget.Designtoolcontroller",
	[epages.widget.LocalizedWidget],
	{
		/**
		 * public properties
		 */
		uri                : '?',
		id                 : 'Designtoolcontroller',
		undobuttonsId      : 'undoWidget',
		objectTreeId       : 'contentExplorerObjectTree',
		eventHandler       : '',
		imageUrl           : epages.vars.StoreRoot ? epages.vars.StoreRoot + '/BO/icons' : undefined,

		/**
		 * private properties
		 */
		 objects   : {},
		 pagetypes : {},
		_dialogWidget      : undefined,
		_visiblePageType : undefined, // _showDesignTools

		/**
		 * widget properties
		 */
		templateString:"<div class=\"Designtoolcontroller\" dojoAttachPoint=\"ControllerNode\">\n  <div dojoAttachPoint=\"ContainerNode\"></div>\n</div>\n",
		translationName  : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/translation'),

		postCreate: function() {
			this.inherited("postCreate", arguments);
			dojo.subscribe(this.objectTreeId+'/select', this, '_onSelectObject');
			dojo.subscribe('Designtool/select', this, '_onSelectDesigntool');
			//set Reference to EventHandler if exists
			this.eventHandler = typeof contentEventHandler != 'undefined' ? contentEventHandler : undefined;
		},

		_createInputsForUndo: function (objectId) {
			var templates = this.objects[objectId].templates;
			var inputFields = {};
			var me = this;
			$H(templates).each( function(pair){
				var inputField = document.createElement('input');
				inputField.type = "hidden";
				inputField.name = objectId +':'+ pair.key + ':1:LayoutUndo';
				inputField.value = pair.value; // read current values
				inputField.size = 4;
				me.ControllerNode.appendChild(inputField);
				me.connect(inputField, 'onchange', 'callOnChange');
				var undoObject = $$(me.undobuttonsId).getUndoObject();
				undoObject.setDefaultValue(inputField);
				inputFields[pair.key] = inputField;
			});
			return inputFields;
		},

		_loadObject:function(node){
			if (this.objects[node.item.objectId] === undefined) {
				var json = new epages.io.Json();
				var output = json.loadSync(this.uri, {
					ObjectID:       node.item.objectId,
					ViewAction:     'JSONLayout',
					KnownPageTypes: $H(this.pagetypes).keys()
				});
				this.objects[node.item.objectId] = {
					templates : output.data.Templates,
					pagetype  : output.data.PageType,
					treeNode  : node
				};
				if (this.pagetypes[output.data.PageType] === undefined) {
					this.pagetypes[output.data.PageType] = {
						templates  : output.data.TemplateTypes,
						controller : undefined
					};
				}
			}
		},

		_showDesignTools: function (objectId) {
			$('Designbox').style.display = 'none';
			// hide old
			if (this._visiblePageType !== undefined) {
				$A(this.pagetypes[this._visiblePageType].controller).each(function (widget) {
					widget.hide();
				});
			}

			// create new if necessary
			var pagetype = this.objects[objectId].pagetype;
			if (this.pagetypes[pagetype].controller === undefined) {
				this.pagetypes[pagetype].controller = this._createDesigntoolcontroller(pagetype,objectId);
			}

			// show new
			this._visiblePageType = pagetype;
			var templates = this.objects[objectId].templates;
			if(this.pagetypes[pagetype].controller.length != 0){
				$A(this.pagetypes[pagetype].controller).each(function (widget) {
					if(templates[widget.folder] != 0){
						widget.setOption(templates[widget.folder],false,objectId);
						widget.show();
					}
				});
				//correct Layout if some Designtools are hidden
				var first = true;
				$A(this.pagetypes[this._visiblePageType].controller).each(function (widget) {
					if(widget.visible && first){
						widget.isfirst = true;
						widget.setSeperator(false);
						first = false;
					}
					else{
						widget.isfirst = false;
						widget.setSeperator(true);
					}
				});
				//show Designtoolcontroller
				$('Designbox').style.display = '';
			}
			//hide Designtoolcontroller if there are no templates for this pagetype
			else{
				$('Designbox').style.display = 'none';
			}
		},

		_onSelectObject: function(node){
			this._loadObject(node);
			this._showDesignTools(node.item.objectId);
		},

		allowSelectLayout: function(widgetId){
			//check if changes in page where made an ask to save them before opening Designtool
			if($$(this.undobuttonsId) !== undefined && $$(this.undobuttonsId).existsChanges()){
				this._activDesigntoolId = widgetId;
				if(!this._dialogWidget){
					 this._createDialog();
				}
				this._dialogWidget.show();
			}
			else{
				//if no changes where made open Designtool
				$$(widgetId).openMenuWidget();
			}
		},

		_createDialog: function(){

			var messageWidget = new epages.widget.Message({
				headline:this.translation.get("SaveQuestion"),
				message: this.translation.get("ChangeLayoutDescription"),
				sizeClass:"Large",
				typeClass:"Warning"
			});

			var me =this;
			var buttons = [{
				label: this.translation.get("Save"),
				cssClass: 'Active',
				onclick: function() {
					this._modalDialogWidget.hide();
					//if Save was clicked, undowidget saves changes
					$$(me.undobuttonsId).sendChanges();
					//open Designtool
					$$(me._activDesigntoolId).openMenuWidget();
				}
			},
			{
				label: this.translation.get("Cancel"),
				onclick: function() {
					this._modalDialogWidget.hide();
				}
			}];
			this._dialogWidget = new epages.widget.Modaldialog({
				id: "Designtoolcontroller_DialogWidget",
				options:{
					title : this.translation.get("ChangeOnLayout"),
					width : 400,
					height: 120,
					content: messageWidget
				},
				buttons : buttons

			});
			document.body.appendChild(this._dialogWidget.domNode);

		},

		_createDesigntoolcontroller: function(pagetype,objectId){
			if(this.imageUrl){
				var returnArray = [];
				var templates = this.pagetypes[pagetype].templates;
				for(templateTypeFolder in templates){
					var info = templates[templateTypeFolder];
					if (info.Variations.length) {
						var widget = new epages.cartridges.de_epages.design.widget.Designtool({
							folder       : templateTypeFolder,
							objectId     : objectId,
							title        : info.NameOrAlias,
							data         : info.Variations,
							imagedir     : this.imageUrl,
							controllerId : this.id,
							position     : info.Position
						});
						returnArray.push(widget);
					}
				}
				dojo.forEach(returnArray.sort(function(a,b) { return a.position - b.position; }), function (el) {
					this.ContainerNode.appendChild(el.domNode);
				}, this);
				return returnArray;
			}
			else{
				return [];
			}
		},

		_onSelectDesigntool:function(opt){

			var widgetId = opt.id;
			var active = $$(widgetId).getActive();
			if(active !== undefined){
				this.changeLayout(active);
			}
		},

		changeLayout:function(active){

			// save changes on server
			var json = new epages.io.Json();
			var params = {
				ObjectID    : active.objectId,
				ViewAction  : 'JSONViewResponse',
				ChangeAction: 'SaveDesign'
			};
			params[active.folder] = active.alias;
			var output = json.loadSync(this.uri, params);
			var objectInfo = this.objects[active.objectId];
			// correct internal data for next time
			objectInfo.templates[active.folder] = active.templateTypeId;
			if($$(this.undobuttonsId) !== undefined){
				$$(this.undobuttonsId).sendChanges();
			}
			// reload content if contentEventHandler is defined
			if(this.eventHandler !== undefined){
				 this.eventHandler.reloadContent(active.objectId, true);
			}
			//update page cache flag
			if(typeof pageCache_SetStatus == 'function'){
				pageCache_SetStatus(true);
			}
		},

		callOnChange: function(evt){
			var name = evt.target.name.split(':');
			var templateType = evt.target.value;
			var objectId = name[0];
			var templateTypeFolder = name[1];
			var pagetype = this.objects[objectId].pagetype;
			for( var i=0,iLength=this.pagetypes[pagetype].controller.length ; i<iLength ; i++ ){
				if(this.pagetypes[pagetype].controller[i].folder == templateTypeFolder){
					var designtool = this.pagetypes[pagetype].controller[i];
					designtool.setOption(templateType,true,objectId);
					this._showDesignTools(objectId);
					//$$(this.objectControllerId).selectNode(this.objects[objectId].treeNode);
				}
			}


		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.TagEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.TagEditor"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.TagEditor");






parent.epages.cartridges.de_epages.content.widget.valueGrouped = {}; // collection of all selected tags in TagEditors grouped by a groupname

dojo.declare(
	"epages.cartridges.de_epages.content.widget._TagEditorMenu",
	dijit.form._ComboBoxMenu,
	{
		templateString: "<ul class='dijitReset dijitMenu dijitTagEditor' style='background-color:#FFF;' dojoAttachEvent='onmousedown:_onMouseDown,onmouseup:_onMouseUp,onmouseover:_onMouseOver,onmouseout:_onMouseOut' tabIndex='-1' style='overflow: \"auto\"; overflow-x: \"hidden\";'>"
			+"<li class='dijitMenuPreviousButton' dojoAttachPoint='previousButton' waiRole='option'></li>"
			+"<li class='dijitMenuNextButton' dojoAttachPoint='nextButton' waiRole='option'></li>"
		+"</ul>",
		itemClasses : "dijitReset",

		createOptions: function(results, dataObject, labelFunc){
			// summary:
			//		Fills in the items in the drop down list
			// results:
			//		Array of dojo.data items
			// dataObject:
			//		dojo.data store
			// labelFunc:
			//		Function to produce a label in the drop down list from a dojo.data item

			//this._dataObject=dataObject;
			//this._dataObject.onComplete=dojo.hitch(comboBox, comboBox._openResultList);
			// display "Previous . . ." button
			this.previousButton.style.display = (dataObject.start == 0) ? "none" : "";
			dojo.attr(this.previousButton, "id", this.id + "_prev");
			// create options using _createOption function defined by parent
			// ComboBox (or FilteringSelect) class
			// #2309:
			//		iterate over cache nondestructively
			dojo.forEach(results, function(item, i){
				var menuitem = this._createOption(item, labelFunc);
				menuitem.className = this.itemClasses;
				dojo.attr(menuitem, "id", this.id + i);
				this.domNode.insertBefore(menuitem, this.nextButton);
			}, this);
			// display "Next . . ." button
			var displayMore = false;
			//Try to determine if we should show 'more'...
			if(dataObject._maxOptions && dataObject._maxOptions != -1){
				if((dataObject.start + dataObject.count) < dataObject._maxOptions){
					displayMore = true;
				}else if((dataObject.start + dataObject.count) > (dataObject._maxOptions - 1)){
					//Weird return from a datastore, where a start + count > maxOptions
					// implies maxOptions isn't really valid and we have to go into faking it.
					//And more or less assume more if count == results.length
					if(dataObject.count == results.length){
						displayMore = true;
					}
				}
			}else if(dataObject.count == results.length){
				//Don't know the size, so we do the best we can based off count alone.
				//So, if we have an exact match to count, assume more.
				displayMore = true;
			}

			this.nextButton.style.display = displayMore ? "" : "none";
			dojo.attr(this.nextButton,"id", this.id + "_next");
			return this.domNode.childNodes;
		}
	}
);

dojo.declare(
	"epages.cartridges.de_epages.content.widget.TagEditor",
	dijit.form.ComboBox,
	{
		templateString: '',
		templateString:"<span id=\"widget_${id}\" style=\"border: 0px;\"\n\tdojoAttachEvent=\"onmouseenter:_onMouse,onmouseleave:_onMouse,onmousedown:_onMouse\" dojoAttachPoint=\"comboNode\" waiRole=\"combobox\" tabIndex=\"-1\"\n\t><span style=\"overflow:hidden;\"\n\t\t><input ${nameAttrSetting} type=\"text\" autocomplete=\"off\" class='dijitReset'\n\t\t\tdojoAttachEvent=\"onkeypress:_onKeyPress,compositionend\"\n\t\t\tdojoAttachPoint=\"textbox,focusNode\" waiRole=\"textbox\" waiState=\"haspopup-true,autocomplete-list\"\n\t\t\tplaceholder=\"${placeholder}\"\n\t/></span\n></span>\n",
		pageSize : 5, // old numberOfEntries

		/**
		 * public properties
		 */

		// this can be used to group multiple TagEditors on the same page
		// if a tag is added, then all TagEditors in the same group will
		// be updated with the new tag
		group:              "", // string - name of all tag inputs which share the same tags
		presetTags:      	"", // string - use this to preset Tags, seperate with ","
		value:              "", // string[]
		name:               "Tags", // string
		delimiter:			',', // string - tagseperator
		placeholder: '',

		description:        '', // string

		// hasDownArrow: [const] Boolean
		//		Set this textbox to have a down arrow button, to display the drop down list.
		//		Defaults to true.
		hasDownArrow: false,

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 100,
		style: '',
		labelType: "html",

		storeType : "epages.cartridges.de_epages.content.widget._TagEditorStore",
		/**
		 * private properties
		 */

		_editAtLastEl  :    true, // is the user edition the last tag in the taglist
		_activeTagIndex:    null, // current working tag

		postMixInProperties: function() {

			this.store = {"dummy":"dummy"};
			this.inherited("postMixInProperties",arguments);
			this.baseClass="";
		},
		postCreate: function() {
			// summary: create store, read preset tags, set input value, subscribe events
			// needs to be done BEFORE inherited

			// read preset tags
			if (typeof(this.presetTags) == "string") {
				this.presetTags = this._splitTags(this.presetTags);
			} else {
				this.presetTags = $A();
			}
			// add preset to value group
			var valueGrouped = parent.epages.cartridges.de_epages.content.widget.valueGrouped;
			// added compatiblity to previous tageditor
			if(dojo.isArray(valueGrouped[this.group])){
				this.presetTags.merge(valueGrouped[this.group]);
				valueGrouped[this.group] = undefined;
			}
			// create tag source
			if (valueGrouped[this.group] === undefined) {
				valueGrouped[this.group] = new(eval(this.storeType))(this.id);
			}
			if (this.presetTags.length) {
				valueGrouped[this.group].mergeIn(this.presetTags);
			}
			if (typeof(this.value) == "string") {
				this.value = this._splitTags(this.value);
			}
			this.store = valueGrouped[this.group];

			// remove dojo magic, someone somewhere deep in dojo sets an id on the input
			this.focusNode.removeAttribute("id");
			this.focusNode = new epages.widget.FormElement({}, this.focusNode).elementNode;
			if (this.delimiter) {
				this.focusNode.value = this.value.join(this.delimiter + ' ');
			} else if(this.value.length){
				this.focusNode.value = this.value[0];
			} else {
				this.focusNode.value = "";
			}
			this.inherited("postCreate",arguments);

			if(this.description.length > 1) {
				this.focusNode.setAttribute("description", this.description);
			}
			//
			this._updatevalue();
			this.connect(this.focusNode, "onkeyup", "_evaluateInput");
			epages.topDojo.subscribe('Createobjectbutton/objectCreated',this,"hide");
			epages.topDojo.subscribe('Createobjectbutton/closed',this,"hide");
		},
		_getQueryString: function(/*String*/ text){
			// overwrite dijit.form.ComboBoxMixin
			// summary: add trim
			return dojo.string.trim(dojo.string.substitute(this.queryExpr, [text]));
		},
		_showResults: function(/*String*/ key,/*Sting?*/lastTyped){
			// - changed popup class
			// - set _activeTagIndex, _editAtLastEl
			if (this.delimiter) {
				var tagList = this.focusNode.value;
				var caretPosition = this._getCaretPos(this.focusNode);
				var countTags = tagList.substr(0, caretPosition).match(new RegExp(this.delimiter, 'g'));
				this._activeTagIndex = countTags ? countTags.length : 0;
				if (!tagList.substr(caretPosition).match(new RegExp(this.delimiter, 'g'))) {
					this._editAtLastEl = true;
				}
				else {
					this._editAtLastEl = false;
				}
			}
			if(!this._popupWidget){
				// create the suggest popup
				var popupId = this.id + "_popup";
				this._popupWidget = new epages.cartridges.de_epages.content.widget._TagEditorMenu({
					onChange: dojo.hitch(this, function(evt){
						this._selectOption(evt);
						if (this.delimiter && evt.target != this._popupWidget.nextButton &&
							evt.target != this._popupWidget.previousButton && this._editAtLastEl) {
							// if last tag is edited and tag is selected add delimitter
							this.focusNode.value = this.focusNode.value + this.delimiter+" ";
						}
					}),
					id: popupId
				});
				dijit.removeWaiState(this.focusNode,"activedescendant");
				dijit.setWaiState(this.focusNode,"owns",popupId); // associate popup with focusNode
			}
			// create a new query to prevent accidentally querying for a hidden
			// value from FilteringSelect's keyField
			var query = dojo.clone(this.query); // #5970
			this._lastInput = lastTyped ? lastTyped : key; // Store exactly what was entered by the user.
			this._lastQuery = query[this.searchAttr] = this._getQueryString(key);
			// #5970: set _lastQuery, *then* start the timeout
			// otherwise, if the user types and the last query returns before the timeout,
			// _lastQuery won't be set and their input gets rewritten
			this.searchTimer=setTimeout(dojo.hitch(this, function(query, _this){
				this.searchTimer = null;
				var fetch = {
					queryOptions: {
						ignoreCase: this.ignoreCase,
						deep: true
					},
					query: query,
					onBegin: dojo.hitch(this, "_setMaxOptions"),
					onComplete: dojo.hitch(this, "_openResultList"),
					onError: function(errText){
						_this._fetchHandle = null;
						console.error('dijit.form.ComboBox: ' + errText);
						dojo.hitch(_this, "_hideResultList")();
					},
					start: 0,
					count: this.pageSize,
					origKey: key,
					tagEditorId: this.id // exclude tags of own id
				};
				dojo.mixin(fetch, _this.fetchProperties);
				this._fetchHandle = _this.store.fetch(fetch);

				var nextSearch = function(dataObject, direction){
					dataObject.start += dataObject.count*direction;
					// #4091:
					//		tell callback the direction of the paging so the screen
					//		reader knows which menu option to shout
					dataObject.direction = direction;
					this._fetchHandle = this.store.fetch(dataObject);
				};
				this._nextSearch = this._popupWidget.onPage = dojo.hitch(this, nextSearch, this._fetchHandle);
			}, query, this), this.searchDelay);
		},
		_startSearch: function(/*String*/ key,/*Sting?*/lastTyped){
			// overwrite dijit.form.ComboBoxMixin
			this._showResults(key,lastTyped);
		},
		_announceOption: function(/*Node*/ node){
			// summary:
			//		a11y code that puts the highlighted option in the focusNode.
			//		This way screen readers will know what is happening in the
			//		menu.
			// overwrite dijit.form.ComboBoxMixin
			if(!node){
				return;
			}
			// pull the text value from the item attached to the DOM node
			var newValue;
			if( node == this._popupWidget.nextButton ||
				node == this._popupWidget.previousButton){
				this.item = undefined;
				this.value = '';
			}else{
				newValue = this.inputLabelFunc(node.item, this.store);
				// get the text that the user manually entered (cut off autocompleted text)
				this.focusNode.value = this.focusNode.value.substring(0, this._lastInput.length);
				// set up ARIA activedescendant
				dijit.setWaiState(this.focusNode, "activedescendant", dojo.attr(node, "id"));
				// autocomplete the rest of the option to announce change
				this._autoCompleteText(newValue);
			}
		},
		_autoCompleteText: function(/*String*/ text){
			// overwrite dijit.form.ComboBoxMixin
			var fn = this.focusNode;
			// IE7: clear selection so next highlight works all the time
			var oldCpos = this._getCaretPos(fn);
			dijit.selectInputText(fn, fn.value.length);
			// does text autoComplete the value in the focusNode?
			var newCpos = this._getCaretPos(fn);
			// only try to extend if we added the last character at the end of the input
			if((newCpos+1) > fn.value.length){
				// only add to input node as we would overwrite Capitalisation of chars
				// actually, that is ok
				var tagList = fn.value;
				if (this.delimiter) {
					var tlSplit = tagList.split(this.delimiter);
					if(tlSplit.length>this._activeTagIndex){
						// replace old with new tag but keep leading and trailing spaces
						tlSplit[this._activeTagIndex] = tlSplit[this._activeTagIndex].replace(/^(\s*).*(\s*)$/,"$1"+text+"$2");
						// calculate chars to select
						var selectEnd = tlSplit.slice(0,this._activeTagIndex+1).join(this.delimiter).length;
						fn.value = tlSplit.join(this.delimiter);
						dijit.selectInputText(fn, oldCpos,selectEnd);
					}
				} else {
					fn.value = tagList.replace(/^(\s*).*(\s*)$/,"$1"+text+"$2");
					dijit.selectInputText(fn, oldCpos);
				}

			}
		},

		_startSearchFromInput: function(){
			// overwrite dijit.form.ComboBoxMixin
			// fix for multi tag
			// calculate tag which is currently under edit
			var tagList = this.focusNode.value;
			var caretPosition = this._getCaretPos(this.focusNode);
			var tag = this._getTagAt(caretPosition, tagList);
			this._startSearch(tag.replace(/([\\\*\?])/g, "\\$1"),this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},
		_startSearchAll: function(){
			// overwrite dijit.form.ComboBoxMixin
			// fix for multi tag
			this._startSearch('',this.focusNode.value.replace(/([\\\*\?])/g, "\\$1"));
		},
		_getTagAt: function(/*int*/position, /*string*/tagList) {
			// summary: recieve the tag from the position of the caret
			// return string
			if (this.delimiter) {
				var leftPos = tagList.substr(0, position).lastIndexOf(this.delimiter);
				leftPos = (leftPos == -1 ? 0 : leftPos + 1);
				var rightPos = tagList.substr(position).indexOf(this.delimiter);
				rightPos = (rightPos == -1 ? tagList.length : rightPos + position);
				return tagList.substring(leftPos, rightPos);
			} else {
				return tagList;
			}
		},
		_evaluateInput: function(evt) {
			// summary: handle key input
			this._updatevalue();
			if (this.delimiter && evt.keyCode == dojo.keys.ENTER && this._editAtLastEl) {
				// add delimiter if edited tag was the last one
				this.focusNode.value = this.focusNode.value + this.delimiter+" ";
			}
		},
		_updatevalue: function() {
			// summary: set the current value to make it accessable
			this.value = this._splitTags(this.focusNode.value);
			this.store.setValue(this.id, this.value);
			dojo.publish(this.id + "/onChange", [{ tags: this.value }]);
		},

		_splitTags: function(/*String*/tagList) {
			// summary: split and trim tagList on delimiter
			// return $A
			var finalTagArray = [];
			if (this.delimiter) {
				var tagArray = tagList.split(this.delimiter);
				for( var i=0,iLength=tagArray.length ; i<iLength ; i++ ) {
					var el = tagArray[i];
					el = el.replace(/^\s*/, "");
					el = el.replace(/\s*$/, "");
					if (el != "") {
						finalTagArray.push(el);
					}
				}
			} else {
				tagList = tagList.replace(/^\s*/, "");
				tagList = tagList.replace(/\s*$/, "");
				if (tagList != "") {
					finalTagArray.push(tagList);
				}
			}
			return $A(finalTagArray);
		},

		getValue: function() {
			return this.focusNode.value;
		},

		setValue: function(newValue) {
			if(newValue) {
				this.value = this.focusNode.value = newValue;
			} else {
				this.value = this.focusNode.value = '';
			}
		},

		hide: function(){
			this._hideResultList();
		},

		labelFunc: function(/*item*/ item, /*dojo.data.store*/ store){
			var itemvalue = store.getValue(item, this.searchAttr);
			var result;
			if(typeof(itemvalue) == 'object') {
				result = itemvalue.labelvalue;
			} else {
				result = itemvalue; // String
			}

			// beautify
			if(this.focusNode.value) {
				var fnv = this.focusNode.value; // 'de'
				var regex = new RegExp(fnv, "g");
				result = result.replace(regex, '<strong>'+fnv+'</strong>'); // 'de_asdasfdasdf'
			}
			return result;
		},

		inputLabelFunc: function(/*item*/ item, /*dojo.data.store*/ store){
			var itemvalue = store.getValue(item, this.searchAttr);
			if(typeof(itemvalue) == 'object') {
				return itemvalue.inputvalue;
			}
			return itemvalue; // String
		}
	}
);

dojo.declare("epages.cartridges.de_epages.content.widget._TagEditorStore", null, {
	availableTags: $A(),
	currentValues: {},
	constructor: function(){},

	mergeIn : function(/*String[]E*/tags){
		// summary: add tags to preset tags
		this.availableTags.merge(tags);
		this.availableTags.unique();
	},
	setValue : function(/*String*/id,/*String[]*/tags){
		// summary: set value of one of the tageditors of the group
		if (tags.length) {
			// prevent empty tags
			this.currentValues[id] = tags;
		}
	},
	getValue: function(	/* item */ item,
						/* attribute-name-string */ attribute,
						/* value? */ defaultValue){
		return item;
	},

	isItemLoaded: function(/* anything */ something){
		return true;
	},

	getFeatures: function(){
		return {"dojo.data.api.Read": true, "dojo.data.api.Identity": true};
	},

	_fetchItems: function(	/* Object */ args,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		// summary:
		//		See dojo.data.util.simpleFetch.fetch()
		if(!args.query){ args.query = {}; }
		if(!args.query.name){ args.query.name = ""; }
		if(!args.queryOptions){ args.queryOptions = {}; }
		// merge preset tags and tags from the editors
		var tags = $A();
		for(var v in this.currentValues){
			if (v != args.tagEditorId) {
				tags.merge(this.currentValues[v]);
			}
		}
		tags.merge(this.availableTags);
		tags.unique();
		var matcher = dojo.data.util.filter.patternToRegExp(args.query.name, args.queryOptions.ignoreCase),
		items = tags.match(matcher);
		if(args.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(args.sort, this));
		}
		findCallback(items, args);
	},

	close: function(/*dojo.data.api.Request || args || null */ request){
		return;
	},

	getLabel: function(/* item */ item){
		return item.innerHTML;
	},

	getIdentity: function(/* item */ item){
		return item;
	}
});
//Mix in the simple fetch implementation to this class.
dojo.extend(epages.cartridges.de_epages.content.widget._TagEditorStore,dojo.data.util.simpleFetch);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.TagInlineEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.TagInlineEditor"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.TagInlineEditor");



dojo.declare(
	"epages.cartridges.de_epages.content.widget.TagInlineEditor",
	[epages.cartridges.de_epages.presentation.widget.InlineEditor],
	{

		availableTags:	'',

		show: function() {
			// TagEditor
			if (!this.isInited) {
				this.object = new epages.cartridges.de_epages.content.widget.TagEditor({
					presetTags: this.availableTags,
					value: this.value,
					name: this.inputName,
					group: 'epages.cartridges.de_epages.content.widget.TagEditor'
				}, this.contentNode);
				this.contentNode = this.object.textbox;
				this.connect(this.object.domNode, 'onblur', 'hide');
				this._copyStyle(this.object.textbox, this._computedStyle);
				// reset color of input text
				this.contentNode.style.color = '';
				if (this.undoObject){ 
					this.undoObject.registerInput(this.contentNode);
				}
				this.connect(this.contentNode, 'onkeyup', 'onChangeContentNode');
				this.connect(this.contentNode, 'onpaste', 'onChangeContentNode');
				this.isInited = true;
			}
			this.displayNode.style.display = 'none';
			this.contentNode.style.display = '';
			this.contentNode.focus();
			this.inherited("show", arguments);
		},

		hide: function() {
			if(this.object){
				this.object.hide();
			}
			if (!this.isInited){ 
				return;
			}
			if (this.contentNode.value == '') {
				this.displayNode.innerHTML = this._placeHolderText;
			} else {
				this.displayNode.innerHTML = this.contentNode.value;
			}
			this.displayNode.style.display = '';
			this.contentNode.style.display = 'none';
			this.inherited("hide", arguments);
		},

		onChangeContentNode: function() {
			this.displayNode.innerHTML = this.object.getValue();
			this.inherited("onChangeContentNode", arguments);
		}

	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.JsonTagEditor"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.JsonTagEditor"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.JsonTagEditor");



dojo.declare("epages.cartridges.de_epages.content.widget._JsonTagEditorStore",
			 epages.cartridges.de_epages.content.widget._TagEditorStore, {
	// parent needs to define a string which is used as subscribe/publish key
	unique:			null,

	constructor: function(unique){
		this.unique = unique;
		dojo.subscribe(this.unique + '/onNewSearchResults', this, "_handleJsonResult");
	},

	_fetchItems: function(	/* Object */ args,
							/* Function */ findCallback,
							/* Function */ errorCallback){
		// summary:
		//		See dojo.data.util.simpleFetch.fetch()
		if(!args.origKey){ args.origKey = ""; }
		// async call to json request function epages.cartridges.de_epages.content.widget.SmartSearchInput
		dojo.publish(this.unique + '/onEvaluateInput', [ args.origKey,dojo.mixin(args,{"findCallback":findCallback})]);
	},
	_handleJsonResult : function(items,args){
		// summary: recieve json result, sort and push it to callback
		if(args.sort){
			items.sort(dojo.data.util.sorter.createSortFunction(args.sort, this));
		}
		if (args.findCallback) {
			args.findCallback(items, args);
		}
	},
	getLabel: function(/* item */ item){
		return item.innerHTML;
	}
});

dojo.declare(
	"epages.cartridges.de_epages.content.widget.JsonTagEditor",
	epages.cartridges.de_epages.content.widget.TagEditor,
	{
		/**
		 * public properties
		 */
		//integer - limited by SMART_PRODUCT_SEARCH_RESULT_COUNT Perl constant
		pageSize:    10,

		// searchDelay: Integer
		//		Delay in milliseconds between when user types something and we start
		//		searching based on that value
		searchDelay: 0,
		// disable multiple tags
		delimiter: null,
		placeholder: '',
		storeType: "epages.cartridges.de_epages.content.widget._JsonTagEditorStore",
		labelType: "html",
    	submitOnEnter: true,	// flag that decides if the form is submitted by using the submit-Event (true) or
                          		// by trigger the event using the fire method (false)
		postCreate: function() {
			this.inherited('postCreate', arguments);
      this.submitOnEnter = epages.string.toBoolean(this.submitOnEnter);
    },
		_onKeyPress: function(/*Event*/ evt){
			var key = evt.charOrCode;
			if(evt.keyCode == dojo.keys.ENTER) {
				if(!this._isShowingNow){
          if(this.submitOnEnter){
					this.focusNode.form.submit();
          }else{
            epages.event.fire(dojo.query('input[type=submit]', this.focusNode.form), "click");
          }
				}
			}
			this.inherited("_onKeyPress",arguments);
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.SmartSearchInput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.SmartSearchInput"] = true;
dojo.provide("epages.cartridges.de_epages.content.widget.SmartSearchInput");



dojo.declare(
	"epages.cartridges.de_epages.content.widget.SmartSearchInput",
	[dijit._Widget, dijit._Templated],
	{
		/**
		 * public properties
		 */
		url                     : '?',  // url for the json action(s)
		ViewAction              : 'JSONSmartSearchObjects',
		inputName               : 'SmartSearch',
		inputStyle              : 'width: 200px',
		value                   : '',    // last input value (i.e. if formerror)
		objectId                : epages.vars.SiteID || '',

		/**
		 * private properties
		 */
		_lastInputValue         : null,  // the last search value
		_timeoutMarker          : null,
		_lastSeachResultCount   : null,
		_searchStartDelay       : 400,   // delay after which time no key was pressed, the search should be started. In msec.
		_minCharactersForSearch : 1,     // how many characters can a user enter before triggering the search

		/**
		 * dojo widget properties
		 */
		templateString:"<span>\n  <span\n    dojoType=\"epages.cartridges.de_epages.content.widget.JsonTagEditor\"\n    availableTags=\"\"\n    dojoAttachPoint=\"SmartSearchBox\"\n    value=\"${value}\"\n    type=\"text\"\n    name=\"${inputName}\"\n    style=\"${inputStyle}\"\n    group=\"\"\n    description=\"\"\n  ></span>\n</span>\n",
		widgetsInTemplate:  true,

		postCreate: function() {
			this.inherited("postCreate",arguments);
			if(this.value) {
				this.SmartSearchBox.setValue(this.value);
			}
			dojo.subscribe(this.SmartSearchBox.id + '/onEvaluateInput', this, "searchBoxKeyUp");
		},

		searchBoxKeyUp: function(/*String*/textInput,/*Object?*/callbackArgs) {
			// fire keyup evt
			// REMOVED dojo.publish(this.id+'/keyup', [ evt ]);
			// check if value changed
			if(this._lastInputValue == textInput || textInput.length <= this._minCharactersForSearch) {
				return;
			}
			// check if last request returned 0 results and if entered value is not the same string plus more chars
			if(this._lastSeachResultCount !== null && this._lastSeachResultCount != '') {
				if(this._lastSeachResultCount === 0 &&
				   textInput.match(new RegExp('^' + this._lastInputValue))) {
				  this._lastInputValue = textInput;
					return;
				}
			}
			// update values
			this._lastInputValue = textInput;
			this.value = textInput;

			// delay requests if keys pressed too fast
			if(this._timeoutMarker) {
				window.clearTimeout(this._timeoutMarker);
			}
			this._timeoutMarker = window.setTimeout(dojo.hitch(this, function(){
				// do search
				this.queryObjectAliases(callbackArgs);
			}), this._searchStartDelay);
		},

		getValue: function() {
			return this.SmartSearchBox.getValue();
		},

		queryObjectAliases: function(callbackArgs) {
			if(!this._lastInputValue) {
				return;
			}
			var inputValue = this._lastInputValue;
			var me = this;
			var json = new epages.io.Json();
			var result = json.loadAsync(this.url,
			function(result){
				if(result.error || !result.data) {
					return;
				}
				// update tageditor available tags ... result.data
				me._lastSeachResultCount = parseInt(result.data.NumResults);
				dojo.publish(me.SmartSearchBox.id + '/onNewSearchResults', [result.data.Results,callbackArgs]);
			},
			{
				'ObjectID' 			: this.objectId,
				'ViewAction'		: this.ViewAction,
				'SearchString' 	: inputValue
			});
		}
	}
);

}

if(!dojo._hasResource["epages.cartridges.de_epages.content.widget.ShortUrlInput"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.content.widget.ShortUrlInput"] = true;
/*
	Copyright (c) 2006-2009, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.content.widget.ShortUrlInput $Revision: 1.11.34.1 $

*/
dojo.provide("epages.cartridges.de_epages.content.widget.ShortUrlInput");









dojo.declare(
	"epages.cartridges.de_epages.content.widget.ShortUrlInput",
	[epages.widget.LocalizedWidget, dijit._Container, dijit._Contained],
	{
		/**
		 * public properties
		 */
		url           : '?',                 // request url
		name          : '',                  // input name
		value         : '',                  // input value (shorturl)
		disabled      : '',                  // flag: input disabled
		nameInputId   : '',                  // string: id of name input
		parentObjectId: '',                  // epages parent ObjectID
		siteId        : epages.vars.SiteID,  // epages SiteID
		classAlias    : '',                  // epages ClassName of parent object
		languageId    : '',                  // language identifier
		contentObjectId: '',                 // epages ObjectID of current object
		formError     : '',                  // flag: 1 = form error occured
		saveButtonId  : '',                  // string: id of save button (register input node)

		/**
		 * private properties
		 */
		_inputTimeout     : undefined,       // save shorturl input timeout
		_nameInputTimeout : undefined,       // save name input timeout
		_isNew            : false,           // flag: indicates wether there was an inital value or not (don't overwrite inital values on name input changes)
		_lastNameValue    : '',              // save last name (to detect real changes / avoid requests)
		_lastValue        : '',              // save last shorturl (to detect real changes / avoid requests)
		_publishButton    : undefined,       // dom node of publish shortURL link

		/**
		 * widget properties
		 */
		templateString:"<div class=\"ShortUrlInput\">\n  <div class=\"InputWrapper\" dojoAttachPoint=\"inputWrapperNode\" >\n    <div class=\"SetHasLayout\"><input class=\"FullWidth\" name=\"${name}\"\n         dojoAttachPoint=\"inputWidget\"\n         value=\"${value}\" type=\"text\"\n         dojoType=\"epages.widget.FormElement\"\n         maxlength=\"255\"\n          /></div>\n  </div>\n  <div dojoAttachPoint=\"displayUrlWrapperNode\" style=\"display:none\">\n    <div class=\"DisplayUrlNode\" dojoAttachPoint=\"displayUrlNode\" ></div>\n    <span dojoAttachPoint=\"editLinkNode\" class=\"CommandLinkSmall\"><span><span class=\"WithIcon Edit\">{Edit}</span></span></span>\n  </div>\n</div>\n",
		translationName: dojo.moduleUrl('epages.cartridges.de_epages.content.widget', 'templates/translation'),
		widgetsInTemplate : true,

		/**
		 * widget life cycle
		 */
		postCreate: function() {
		// summary: initalize shorturl widget
			this.inherited("postCreate", arguments);
			if(this.siteId === undefined) {
				console.warn("epages.vars.SiteID not defined in "+this.declaredClass);
			}

			// create hash with temporary reserved short url (avoids duplicate shorturl on pages with multiple languages)
			if(epages.vars.TemporaryReservedShortUrl === undefined) {
				epages.vars.TemporaryReservedShortUrl = $H();
			}

			// update value in shorturl preview
			this._updateDisplayUrl(this.value);

			// update display of widget depending on its status
			if(this.value != "" && this.formError =="") {      // has inital value / no form error
				if(this.disabled != "disabled") {                // input is not disabled
					// show shorturl preview instead of shorturl input
					this.inputWrapperNode.style.display="none";
					this.displayUrlWrapperNode.style.display="";

					// (dirty) label formatting
					var labelNode = $('Label'+this.id);
					if(labelNode !== undefined && labelNode != null) {
						dojo.removeClass(labelNode, "InputLabelling");
						var tableNode = labelNode.parentNode.parentNode.parentNode;
						epages.html.replaceClass(tableNode, "InnerGrid", "FormGrid");
					}
				}
			} else if(this.formError =="1") {                  // set form error
				this._setError(true);
			} else {                                           // set flag _isNew
				this._isNew=true;
			}

			if(this.disabled=="disabled") {
				this.inputWidget.domNode.disabled= true;
			} else {
				// attach events
				this.connect(this.displayUrlWrapperNode, "onclick", "onClickEditLinkNode");
				this.connect(this.inputWidget.domNode, "onkeypress", "onKeypressInputNode");
				this.connect(this.inputWidget.domNode, "onchange", "onChangeInputNode");

				if(this.nameInputId != "") {
					var niNode=$(this.nameInputId);
					if(niNode) {
						this._lastNameValue = niNode.value;
						this.connect(niNode, "onchange", "onChangeNameInputNode");
						this.connect(niNode, "onkeypress", "onKeypressNameInputNode");
					}
				}

				// save the "publish short url" button
				var button = $('CommandLink-'+this.id);
				if(button) {
					this._publishButton = button;
				}
				this._updatePublishButton();

				// register input to specified save button
				dojo.addOnLoad(dojo.hitch(this, function() {
					var saveButton = $$(this.saveButtonId);
					if(saveButton !== undefined){
						saveButton.registerInput(this.inputWidget.domNode);
					} else {
						console.warn("Savebutton (id="+this.saveButtonId+") not found in "+this.declaredClass);
					}
				}));
			}
		},

		/**
		 * events
		 */

		onClickEditLinkNode : function(evt) {
		// summary: show short url input node and show info bubble
			this.inputWrapperNode.style.display="";
			this.displayUrlWrapperNode.style.display="none";
			this.inputWidget.domNode.focus();

			// (dirty) label formatting
			var labelNode = $('Label'+this.id);
			if(labelNode !== undefined) {
				dojo.addClass(labelNode, "InputLabelling");
				var tableNode = labelNode.parentNode.parentNode.parentNode;
				epages.html.replaceClass(tableNode, "FormGrid", "InnerGrid");
			}

			//display Info Bubble
				var position = $E(this.inputWidget.domNode).getAbsolutePosition();
				dojo.publish("uimessage/show", ["", this.translation.get('EditShortURLNotification'), "Bubble", {
					typeClass: "",
					sizeClass: "Small",
					x: position.x,
					y: (position.y + this.inputWidget.domNode.clientHeight + 4)
				}]);
		},

		onKeypressInputNode: function(evt) {
		// summary: handle keypress of shorturl input field - trigger onchange event after timeout
			dojo.publish("uimessage/hide", []);
			this._clearTimeouts();

			var _this = this;
			var iNode=this.inputWidget.domNode;
			this._inputTimeout = window.setTimeout( function() {
				epages.event.fire(iNode, "change");
			}, 100);
		},

		onKeypressNameInputNode: function(evt) {
		// summary: handle keypress of name input field - trigger onchange event after timeout
			this._clearTimeouts();

			var _this = this;
			var niNode=$(this.nameInputId);
			this._nameInputTimeout = window.setTimeout( function() {
				epages.event.fire(niNode, "change");
			}, 200);
		},

		onChangeInputNode: function(evt) {
		// summary: handle changes on input node - send request for a valid short url
			var v = this.getValue();
			this._clearTimeouts();
			this._updatePublishButton();
			if(this._lastValue != v) {                      // send request if there were real changes
				var orgName = this.getValue();

				var trimmedName = orgName.replace(/\s/g, ""); // check if string contains only space chars
				if(trimmedName != "") {
					var resShorturlString =	this._getTemporyReservedUrl();

					// build form data
					var request = new epages.io.Json();
					var formData = {
						'ViewAction' : 'JSONValidateShortURL',
						'ObjectID'   : this.siteId,
						'ParentID'   : this.parentObjectId,
						'ShortUrl'   : orgName,
						'ClassName'  : this.classAlias
					};

					// optinal form data
					if(this.contentObjectId != "") {
						formData['ContentObjectID'] = this.contentObjectId;
					}

					if(this.languageId != "") {
						formData['LanguageID'] = this.languageId;
					}

					if(resShorturlString != "") {
						formData['TemporaryReserved']=resShorturlString;
					}

					// send request
					request.loadAsync(this.url,
						epages.lang.hitch(this, function (result) { this._validateShortUrl_requestOk(result);}),
						formData,
						epages.lang.hitch(this, function (result, data) { this._getShortUrl_requestFailed(result, data);})
					);
				} else {
					this._setError(false);
				}
			}
		},

		triggerChangeNameInputNode: function() {
		// summary: public port to trigger new short URl suggest from outside
			this._clearTimeouts();
			this._updatePublishButton();

			var resShorturlString =	this._getTemporyReservedUrl();
			var orgName=$(this.nameInputId).value;

			// build form data
			var request = new epages.io.Json();
			var formData = {
				'ViewAction' : 'JSONGenerateShortURL',
				'ObjectID'   : this.siteId,
				'ParentID'   : this.parentObjectId,
				'Name'       : orgName,
				'ClassName'  : this.classAlias
			};

			// optinal form data
			if(this.languageId != "") {
				formData['LanguageID'] = this.languageId;
			}

			if(resShorturlString != "") {
				formData['TemporaryReserved']=resShorturlString;
			}

			// send request
			request.loadAsync(this.url,
				epages.lang.hitch(this, function (result) { this._getShortUrl_requestOk(result);}),
				formData,
				epages.lang.hitch(this, function (result, data) { this._getShortUrl_requestFailed(result, data);})
			);

			var niNode=$(this.nameInputId);
			this._nameInputTimeout = window.setTimeout( function() {
				epages.event.fire(niNode, "change");
			}, 2000);
		},

		onChangeNameInputNode: function(evt) {
		// summary: handle changes of name input field
			this._clearTimeouts();
			this._updatePublishButton();

			// send request only  if there were real changes and there were no initial value (don't overwrite current value)
			if((this.inputWidget.domNode.value == "" || this._isNew) &&
					this._lastNameValue != this.getNameValue()) {

				var resShorturlString =	this._getTemporyReservedUrl();
				var orgName=$(this.nameInputId).value;

				// build form data
				var request = new epages.io.Json();
				var formData = {
					'ViewAction' : 'JSONGenerateShortURL',
					'ObjectID'   : this.siteId,
					'ParentID'   : this.parentObjectId,
					'Name'       : orgName,
					'ClassName'  : this.classAlias
				};

				// optinal form data
				if(this.languageId != "") {
					formData['LanguageID'] = this.languageId;
				}

				if(resShorturlString != "") {
					formData['TemporaryReserved']=resShorturlString;
				}

				// send request
				request.loadAsync(this.url,
					epages.lang.hitch(this, function (result) { this._getShortUrl_requestOk(result);}),
					formData,
					epages.lang.hitch(this, function (result, data) { this._getShortUrl_requestFailed(result, data);})
				);
			}
		},

		/**
		 * getter, setter, other methods
		 */
		setValue: function(/* string */v, /* boolean? */ isValidated) {
		// summary: setter function - set value of input value
		// v: new value
		// isValidated: indicates if shorturl was validated (eg. proposal from server)
			this.inputWidget.domNode.value = v;
			this._lastValue = v;
			if(isValidated) {
				this._setTemporyReservedUrl();
				this._setError(false);
				dojo.publish("uimessage/hide", []);
			}
		},

		getValue: function() {
		// summary: returns short url input value
			return this.inputWidget.domNode.value;
		},

		getNameValue: function() {
		// summary: returns name input value
			var niNode=$(this.nameInputId);
			if(niNode) {
				return niNode.value;
			} else {
				return false;
			}
		},

		_clearTimeouts: function() {
		// summary: clear all timeouts
			if(this._inputTimeout !== undefined) {
				window.clearTimeout(this._inputTimeout);
			}

			if(this._nameInputTimeout !== undefined) {
				window.clearTimeout(this._nameInputTimeout);
			}
		},

		_setError : function(/* boolean */ setError) {
		// summary: set or remove error class on short url input
			if(setError) {
				dojo.addClass(this.inputWidget.domNode, "DialogError");
			} else {
				dojo.removeClass(this.inputWidget.domNode, "DialogError");
			}
		},

		_setTemporyReservedUrl: function() {
		// summary: set current value as temporaray reserved url
			var v = this.getValue();
			epages.vars.TemporaryReservedShortUrl.set(this.id, v);
		},

		_getTemporyReservedUrl: function() {
		// summary: returns a string with all reserved url (comma seperated)
				var resShorturl = [];
				var id = this.id;
				epages.vars.TemporaryReservedShortUrl.each(function(pair) {
					if(id != pair[0]) {
						resShorturl.push(pair[1]);
					}
				});
				return resShorturl.join(',');
		},


		_updateDisplayUrl : function(/* string */ v) {
		// summary: update shorturl preview div
			this.displayUrlNode.innerHTML = epages.format.scrunch(v,25, 0.4);
			this.displayUrlNode.title=v;
		},

		_validateShortUrl_requestOk : function(/* epages.io.json result */ result) {
		// summary: call back function (short url node change) - insert generated short url or display short url proposal bubble
			this._lastValue = this.getValue();
			this._setTemporyReservedUrl();
			if(result.data && result.data.Valid) {
				this._setError(false);
			} else {
				this.setValue(result.data.ShortURL,true);
			}
		},

		_updatePublishButton : function() {
		// summary: update commandlink "publish short url"
				if(this.getValue() == "") {
					if(this._publishButton){
						dojo.addClass(this._publishButton, "Disabled");
					}
				} else {
					if(this._publishButton && !dojo.hasAttr(this._publishButton, "title")){
						dojo.removeClass(this._publishButton, "Disabled");
					}
				}
		},

		_getShortUrl_requestOk : function(/* epages.io.json result */ result) {
		// summary: call back function (name input change) - insert generated short url and update
			if(result.data && result.data.ShortURL) {
				this.inputWidget.domNode.value=result.data.ShortURL;		// set short url
				// update display and status
				this._updateDisplayUrl(result.data.ShortURL);
				this._setError(false);
				this._setTemporyReservedUrl();
				this._lastNameValue = this.getNameValue();
				this._updatePublishButton();
			}
		},

		_getShortUrl_requestFailed : function(/* epages.io.json result */ result) {
		// summary: error handling request failed
			var errors = result.data.Errors;
			console.error("An error occured in request (function: onChangeNameInputNode, class: "+this.declaredClass+") ", result.data.Errors);
		}

	}
);

}

